/* eslint-disable no-param-reassign */
import request from '../utils/request';
import post from '../utils/post';
import { cookie } from '../utils/config';
import { getCookie } from '../utils/helper';

export async function fetchDomains(basePath, withRoot = false) {
  if (!basePath) {
    basePath = getCookie(cookie.domainPath);
  }
  const rootDomainInfo = withRoot ? await request('/api/domain/user/info', { dmPath: basePath }) : null;
  const childrenDomainInfoList = await request('/api/domain/user/children-info', { dmPath: basePath });
  let infoList;
  if (rootDomainInfo && childrenDomainInfoList) {
    infoList = [
      rootDomainInfo,
      ...childrenDomainInfoList,
    ];
  } else if (rootDomainInfo) {
    infoList = [rootDomainInfo];
  } else if (childrenDomainInfoList) {
    infoList = childrenDomainInfoList;
  } else {
    infoList = [];
  }
  return infoList;
}

export async function switchDomain(path) {
  return post('/api/domain/user/path', { dmPath: path });
}

export async function currentDomain() {
  return request('/api/domain/user/info');
}
